global eposDrawPolyObject
global eposEArr=#()
global eposPArr=#()
global eposfirsttofirst
global eposDoBR
global drawPolyHasVertCreated = false
global eposDrawPolyContinue = false 

struct eposlibs 
(
	fn bitarrayToArray bitarray_ =
	(
		local outgoing = for BA in bitarray_ collect BA
	),

	fn getSelVerts obj =
	(
		return eposlibs.bitArrayToArray (polyOp.getVertSelection obj)
	),
	
	fn getSelEdges obj =
	(
		return eposlibs.bitArrayToArray (polyOp.getEdgeSelection obj)
	),	
	
	fn getVertNeighbors obj vertId =
	(
		local vertNeighbors=#()
		local sharedEdges=eposlibs.bitarrayToArray(polyop.getEdgesUsingVert obj vertId)

		for i in sharedEdges do
		(
			neighVert=eposlibs.bitarrayToArray(polyop.getVertUsingEdge obj i)

			if neighvert[1]=vertId then
				append vertNeighbors neighVert[2]
			else
				append vertNeighbors neighVert[1]
		)

		return vertNeighbors	
	),

	fn getEdgeNeighbors obj edge =
	(
		local edgeNeighbors=#()
		local edgeVerts=polyOp.getEdgeVerts obj edge
		local tempEdge
	
		for i in edgeVerts do
		(
			local edge=eposlibs.bitarrayToArray(polyOp.getEdgesUsingVert obj i)
			for i in edge do
			(
				append edgeNeighbors i
			)
		)

		tempEdge=findItem edgeNeighbors edge

		while ((tempEdge = (findItem edgeNeighbors edge)) != 0 )do 
			deleteItem edgeNeighbors tempEdge

		return edgeNeighbors
	),
	
	fn getEdgesDistance obj edge1 edge2 =
	(
		local pos1=eposlibs.getAvgVertPos obj (polyOp.getEdgeVerts obj edge1)
		local pos2=eposlibs.getAvgVertPos obj (polyOp.getEdgeVerts obj edge2)
		return distance pos1 pos2
	),
	
	fn getEdgeAngle obj edge1 edge2 =
	(
		local edgeVerts=polyOp.getEdgeVerts obj edge1
		local getref
		local edge1Vect=eposlibs.getFreeEdgeNormal obj edge1
		local edge2Vect=normalize((eposlibs.getEdge obj edge2)-(eposlibs.getEdge obj edge1))
		local edge1L=length edge1Vect
		local edge2L=length edge2Vect
		local dotEdge=dot edge1Vect edge2Vect
		local edgeangle=degtorad(acos (dotEdge/(edge1L*edge2L)))
		
		if edgeangle < 0.5 then
			return edgeangle
		else
			return (1-edgeangle)
	),

	fn getAvgVertNormals obj vertlist =
	(
		local avgNormals=0
		local vertcount=0

		for i in vertlist do
		(
			avgNormals += getNormal obj i
			vertcount += 1
		)

		avgNormals = avgNormals/vertcount

		return avgNormals
	),

	fn getAvgVertPos obj vertlist =
	(
		local avgPos=0
		local vertcount=0

		for i in vertlist do
		(
			avgPos+=polyOp.getVert obj i
			vertcount+=1
		)

		avgPos = avgPos/vertcount

		return avgPos
	),

	fn getVertLocal obj vert ref =
	(
		return ((getVert obj vert)-ref)
	),
	
	fn getVertsAngle obj ref1 ref2 vert =
	(
		local ref1pos=polyOp.getVert obj ref1
		local ref2pos=polyOp.getVert obj ref2
		local vertPos=polyOp.getVert obj vert
		local vert1L=length (normalize(vertPos-ref1pos))
		local vert2L=length (normalize(ref2pos-ref1pos))
		local dotvert=dot (normalize(vertPos-ref1pos)) (normalize(ref2pos-ref1pos))
		local vertangle=degtorad(acos (dotvert/(vert1L*vert2L)))
		
		if vertangle < 0.5 then
			return vertangle
		else
			return (1-vertangle)
	),
	
	fn getPointsAngle pt1 pt2 pt3 =
	(
		local ref1pos=pt2
		local ref2pos=pt3
		local vertPos=pt1
		local vert1L=length (normalize(vertPos-ref1pos))
		local vert2L=length (normalize(ref2pos-ref1pos))
		local dotvert=dot (normalize(vertPos-ref1pos)) (normalize(ref2pos-ref1pos))
		local vertangle=degtorad(acos (dotvert/(vert1L*vert2L)))
		
		if vertangle < 0.5 then
			return vertangle
		else
			return (1-vertangle)
	
	),
	
	fn isEdgeNeighbor obj edge1 edge2 =
	(
		local edgeNeigh=eposlibs.getEdgeNeighbors obj edge1
		
		if (finditem edgeNeigh edge2) == 0 then
			return false
		else 
			return true
	),
	
	fn getFreeEdgeNormal obj edge =
	(
		local facearr=eposlibs.bitarrayToArray(polyOp.getFacesUsingEdge obj edge)
		local facepos=polyop.getfacecenter obj facearr[1]
		local edgepos=eposlibs.getEdge obj edge
		
		return normalize (edgepos - facepos)
	),
	
	fn getEdge obj edge=
	(
		local edgeVerts=polyOp.getEdgeVerts obj edge
		return edgepos=((polyop.getvert obj edgeVerts[2])+(polyop.getvert obj edgeVerts[1]))/2
	),
	
	fn splitContEdgesArr obj arr=
	(
		local tempArr=#()
		local oldtemp
		local Arr1=#()
		local Arr2=#()
		local ArrHl=arr.count/2
		
		for i in arr do append tempArr i

		Arr1=eposlibs.sortContEdges obj tempArr
		
		for i in arr do
		(
			if ((finditem Arr1 i) == 0) then
				append Arr2 i
				
			if Arr2.count == ArrHl then exit	
		)
		
		Arr2=eposlibs.sortContEdges obj Arr2
		
		
		
		
		return (join Arr1 Arr2)
	),
	
	fn sortContEdges obj arr =
	(
		local inputArr=#()
		local output=#()
		local oldedge
		
		for i in arr do append inputArr i
		local isRing = eposlibs.isEdgeLoopARing obj arr
		
		if isRing == false then
		(
			for i=1 to arr.count do
			(
				local temp1=0
				local temp2
			
				for j=1 to arr.count do
				(
					if (eposlibs.isEdgeNeighbor obj arr[i] arr[j]) == true then
						temp1+=1
				
					temp2=j
					
					if temp1 == 2 then 
						exit
				
				)
			
				if temp1 == 1 then
				(
					append output arr[i]
					oldedge = arr[i]
					deleteitem inputArr i
					exit
				)
			
			)
		)
		else
		(
			oldedge=arr[1]
			append output arr[1]
			deleteitem inputArr 1
		)
		

		for i=1 to arr.count do
		(
			local ic=inputArr.count
			j=1
			
			while inputArr.count != 0 do --for j=1 to inputArr.count do
			(
				if (eposlibs.isedgeneighbor obj oldedge inputArr[j]) == true then 
				(
					append output inputArr[j]
					oldedge=inputArr[j]
					deleteItem inputArr j
					
				)
				
				if j > ic then exit
				
				j +=1
			)
		)
		
		--if isRing == true then deleteItem output output.count
		
		return output
	),
	
	fn isEdgeLoopARing obj arr =
	(
		local testedge = #()
		local testbed = testedge[1]
		local ringarr = 0
		
		
		for i in arr do append testedge i
		
		for i in arr do
		(
			local temp1=0
			
			for j=1 to testedge.count do
			(
				
				
				if (eposlibs.isEdgeNeighbor obj i testedge[j]) == true then
				(
					temp1 += 1
				)
				
				if temp1 == 2 then
				(
					ringarr +=1
					exit
				)
			)
		)	

		if ringarr == arr.count then
			return true
		else
			return false
			 
	),

	fn blendEdgesMouseCallback msg ir obj faceNum shift ctrl alt = ---not used
	(
		local ArrHalf=eposEArr.count/2

		displayTempPrompt "Left click to reverse blend, right click to end operation" 10000

		if msg == #freeMove then return #continue

		if msg == #mousePoint then 
		(
			eposDoBR = true
			exit
		)
		
		if msg != #mouseAbort then return #continue		
		
		if msg == mouseAbort then
		(
			eposDoBR = false
			exit
		)
	),
	
	fn drawPolyMouseCallback msg ir o faceNum shift ctrl alt =
	(
		if msg == #freemove then (setSysCur #select; return #continue)

		if msg == #mousePoint then 
		(
			--if drawPolyHasVertCreated == false then 
			drawPolyHasVertCreated = true
			
			if ir != undefined then
			(
				polyop.createVert eposDrawPolyObject ir.pos node:$
				redrawViews()
				return #continue
			)
			else
			(
				displayTempPrompt "Not on surface" 5000
			)
			setSysCur #select
		)
	
		if msg != #mouseAbort then 
			return #continue
		else
		(
			if shift == true then eposDrawPolyContinue = true
		)
	),
	
	fn setEdge obj edge newpos =
	(
		local vert1 = (polyop.getedgeverts obj edge)[1]
		local vert2 = (polyop.getedgeverts obj edge)[2]
		
		local oldpos = ((polyop.getvert obj vert1) + (polyop.getvert obj vert2))/2
		
		local movevertpos = newpos - oldpos
		
		enableSceneRedraw()
		polyop.movevert obj vert1 movevertpos
		polyop.movevert obj vert2 movevertpos
		enableSceneRedraw()
		redrawviews()
	)
)

struct epos
(
	fn drawPoly polyobj onSurf =
	(
		global eposDrawPolyObject=polyobj
		eposDrawPolyContinue = false
		local vertsArr=#()
		local numEdges=1 + polyop.getNumEdges polyobj
		local startVert = 1 + polyop.getNumVerts polyobj
		local endvert
	
		subObjectLevel = 1
	
		if onSurf == true then 
			mouseTrack on:polyobj trackCallback:eposlibs.drawPolyMouseCallback
		else 
			mouseTrack trackCallback:eposlibs.drawPolyMouseCallback
	
		endVert=polyop.getNumVerts polyobj
		
		with redraw off
		(
		
			for i=startVert to endVert do append vertsArr i
			
			local newpoly = polyop.createPolygon polyobj vertsArr
		
			
			if newpoly != undefined then
			(
				newpolynorm = polyop.getfacenormal polyobj newpoly node:$
				viewTM = inverse(viewport.getTM())
				viewdir = (ray viewTM.row4 viewTM.row3).dir
				
				dotVal = dot newpolynorm viewDir
				
				viewNormAngle = acos (dotVal)
				
				--print (abs viewNormAngle)
				
				if (abs viewNormAngle) > 90 then 
				(
					polyOp.deleteFaces polyobj newpoly delIsoVerts:false
					vertsArr=#()
					for i=endVert to startVert by -1 do append vertsArr i
					newpoly = polyop.createPolygon polyobj vertsArr 
					
				)
				
				while (numEdges) <= (polyOp.getNumEdges polyobj) do
				(
					polyOp.SetEdgeVis polyobj numEdges true
					numEdges+=1	
				)
			)
		)
		if eposDrawPolyContinue == true then
			epos.drawPoly eposDrawPolyObject 0
		else
			eposDrawPolyObject=undefined
	
	),

	fn averageVertices obj vertBitArray =
	(
		local vertArray = for v in vertBitArray collect v
		local vertPos = #()
		local vertAvgPos =#()
		
		setWaitCursor()
		with redraw off
		(	
			for i=1 to (polyOp.getNumVerts obj) do
				append vertAvgPos (polyOp.getVert obj i)
			
			for i=1 to vertArray.count do
			(
				local edgeArr = for j in (polyOp.getEdgesUsingVert obj vertArray[i]) collect j
				local edgePos = 0
			
				for j in edgeArr do
				(
					eVertArr = for k in (polyOp.getVertsUsingEdge obj j) collect k
					edgePos += ((vertAvgPos[evertArr[1]]) + (vertAvgPos[eVertArr[2]]))/2
				)
				
				append vertPos (edgePos/edgeArr.count)
			)
				
			for i=1 to vertArray.count do
				polyOp.setVert obj vertArray[i] vertPos[i]
		)
		setArrowCursor()
	),

	fn blend2Edges obj edge1 edge2=
	(
		if ((eposlibs.isEdgeNeighbor obj edge1 edge2) == false) then
		(	
			disableSceneRedraw()
			local numEdges=(polyop.getNumEdges obj)+1
			local edge1Verts=polyOp.getEdgeVerts obj edge1
			local edge2Verts=polyOp.getEdgeVerts obj edge2
			local vert1=edge1Verts[1]
			local vert2=edge1Verts[2]
			local vert3=edge2Verts[1]
			local vert4=edge2Verts[2]
			local vertT
			local faceVerts=#()
			local invFaceVerts=#()
			local edgeVisId=1
			local dist1to3=distance (polyOp.getvert obj vert1) (polyOp.getvert obj vert3)
			local dist1to4=distance (polyOp.getvert obj vert1) (polyOp.getvert obj vert4)
			local angle1to3=eposlibs.getVertsAngle obj vert1 vert2 vert3
			local angle1to4=eposlibs.getVertsAngle obj vert1 vert2 vert4

			if ((dist1to3 <= dist1to4) and (angle1to3 <= angle1to4)) then
			(
				append faceVerts vert1
				append faceVerts vert3
				vertT=vert4
			)
			else
			(
				append faceVerts vert1
				append faceVerts vert4
				vertT=vert3
			)
		
			append faceVerts vertT
			append faceVerts vert2
		
			try
			(
				polyOp.createPolygon obj faceVerts
				--global hmm = faceverts
				--for i in faceverts do print i
				--print "hi"
			)
			catch
			(
				for i=1 to 4 do invFaceVerts[i]=faceVerts[5-i]
				polyOp.createPolygon obj invFaceVerts
			)

			while ((numEdges) <= (polyOp.getNumEdges obj)) do
			(
				polyOp.SetEdgeVis obj numEdges true
				numEdges+=1
			)
				
			--update obj
			enableSceneRedraw()
			redrawViews()
		)
		else
			displayTempPrompt "Cannot blend edges. The edges share the same vertex." 10000
	),
	
	fn blendEdges obj edgesarray =
	(

		if (mod (edgesarray.count) 2) == 0.0 then
		(
			disableSceneRedraw()

			local edgesArrSplit=eposlibs.splitContEdgesArr obj edgesarray
			local edgesArr1=#()
			local edgesArr2=#()
			local cornerEdges=#()
			local facesCreated=#()
			local edgesHC=edgesarray.count/2
			local startFaceCount=(polyop.getNumFaces obj)+1
			local endFaceCount
			local blendReverse
			local firsttofirst
			
			for i=1 to edgesHC do
			(
				append edgesArr1 edgesArrSplit[i]
			)
			
			for i=(edgesHC+1) to edgesarray.count do
			(
				append edgesArr2 edgesArrSplit[i]
			)
			
			cornerEdges[1]=edgesArrSplit[1]
			cornerEdges[2]=edgesArrSplit[edgesHC]
			cornerEdges[3]=edgesArrSplit[edgesHC+1]
			cornerEdges[4]=edgesArrSplit[edgesArrSplit.count]
			
			local dist1=eposlibs.getedgesdistance obj cornerEdges[1] cornerEdges[3]
			local dist2=eposlibs.getedgesdistance obj cornerEdges[1] cornerEdges[4]
			local ang1=eposlibs.getPointsAngle (eposlibs.getEdge obj cornerEdges[1]) (eposlibs.getEdge obj cornerEdges[3]) (eposlibs.getEdge obj cornerEdges[4])
			local ang2=eposlibs.getPointsAngle (eposlibs.getEdge obj cornerEdges[2]) (eposlibs.getEdge obj cornerEdges[3]) (eposlibs.getEdge obj cornerEdges[4])
			
			if (dist1 <= dist2) and (ang1 <= ang2) then
			(

				for i=1 to (edgesHC) do
					epos.blend2edges obj edgesArrSplit[i] edgesArrSplit[edgesHC+i]

				firsttofirst=true
			)
			
			else
			(
				for i=1 to edgesHC do
					epos.blend2edges obj edgesArrSplit[i] edgesArrSplit[edgesArrSplit.count+1-i]
	
				firsttofirst=false
			)
			
			endFaceCount=polyop.getNumFaces obj
			
			for i=startFaceCount to endFaceCount do append facesCreated i
			
			enableSceneRedraw()
			redrawviews()
			PushPrompt "Press Yes to keep the blending faces. Press No to reverse the blending polygons" --5000
			eposDoBR=queryBox "Do you want to reverse the blending polygons?" title:"Blend Edges"
			PopPrompt()
			
			--eposDoBr = false
			disableSceneRedraw()
			
			if eposDoBR == true then
			(
				local temp1=0
				
				local cmdstr = 
				polyop.deleteFaces obj facescreated delisoverts:true
				
				global passone=1

			
				if firsttofirst != false then
				(

					for i=1 to edgesHC do
						epos.blend2edges obj edgesArrSplit[i] edgesArrSplit[edgesArrSplit.count+1-i]
				)
				else
				(

					for i=1 to edgesHC do
						epos.blend2edges obj edgesArrSplit[i] edgesArrSplit[edgesHC+i]
				)

			)

			eposDoBR=undefined

			enableSceneRedraw()
			redrawViews()
		)
		else
		(
			enableSceneRedraw()
			redrawViews()
			displayTempPrompt "Invalid edge selection." 6000
		)
	),
	
	fn blendNeighEdges obj edge1 edge2 =
	(
		if (eposlibs.isedgeneighbor obj edge1 edge2) == true then
		(
			local vertCenter
			local vertsEdge1=polyop.getEdgeverts obj edge1
			local vertsEdge2=polyop.getEdgeVerts obj edge2
			local triVerts
			
			if (finditem vertsEdge2 vertsEdge1[1]) != 0 then
			(
				vertCenter = vertsEdge1[1]
				triVerts=#(vertsEdge1[2],vertsEdge1[1])
			)
			else
			(
				vertCenter = vertsEdge1[2]
				triVerts=#(vertsEdge1[1],vertsEdge1[2])
			)
			
			if (finditem vertsEdge2 vertCenter) == 1 then			
				append triVerts vertsEdge2[2]
			else
				append triVerts vertsEdge2[1]
				
			polyop.createPolygon obj triverts
				
		)
	),
	
	fn join2edges obj edge1 edge2 =
	(

			local edge1pos = eposlibs.getEdge obj edge1
			local edge2pos = eposlibs.getEdge obj edge2
			local edgeCtr = ((eposlibs.getedge obj edge1) + (eposlibs.getedge obj edge2))/2
			
			disableSceneRedraw()
			eposlibs.setedge obj edge1 edgectr
			eposlibs.setedge obj edge2 edgectr
			polyop.weldEdges obj edge1 edge2
			enableSceneRedraw()
			redrawViews()

	),
	
	fn joinEdges obj edgesarray =
	(
		if (mod (edgesarray.count) 2) == 0.0 then
		(
			with redraw off
			(
				local edgesArrSplit=eposlibs.splitContEdgesArr obj edgesarray
				local edgesArr1=#()
				local edgesArr2=#()
				local cornerEdges=#()
				local facesCreated=#()
				local edgesHC=edgesarray.count/2
				local startFaceCount=(polyop.getNumFaces obj)+1
				local endFaceCount
				local blendReverse
				local firsttofirst
				
				for i=1 to edgesHC do
				(
					append edgesArr1 edgesArrSplit[i]
				)
				
				for i=(edgesHC+1) to edgesarray.count do
				(
					append edgesArr2 edgesArrSplit[i]
				)
				
				cornerEdges[1]=edgesArrSplit[1]
				cornerEdges[2]=edgesArrSplit[edgesHC]
				cornerEdges[3]=edgesArrSplit[edgesHC+1]
				cornerEdges[4]=edgesArrSplit[edgesArrSplit.count]
				
				local dist1=eposlibs.getedgesdistance obj cornerEdges[1] cornerEdges[3]
				local dist2=eposlibs.getedgesdistance obj cornerEdges[1] cornerEdges[4]
				local ang1=eposlibs.getPointsAngle (eposlibs.getEdge obj cornerEdges[1]) (eposlibs.getEdge obj cornerEdges[3]) (eposlibs.getEdge obj cornerEdges[4])
				local ang2=eposlibs.getPointsAngle (eposlibs.getEdge obj cornerEdges[2]) (eposlibs.getEdge obj cornerEdges[3]) (eposlibs.getEdge obj cornerEdges[4])
				
				undo "Join Edges" on
				(
					print edgesArrSplit
					if (dist1 <= dist2) then--and (ang1 >= ang2) then
					(
						local subtval = 0
						for i=1 to (edgesHC) do
						(
							polyOp.weldEdges obj (edgesArrSplit[i] - subtVal) (edgesArrSplit[edgesHC+i] - subtVal)
							subtVal += 1
						)
		
					)
					
					else
					(
						local subtval = 0
						
						for i=1 to edgesHC do
						(
							polyop.weldEdges obj (edgesArrSplit[i] - subtVal) (edgesArrSplit[edgesArrSplit.count+1-i] - subtVal)
							subtVal += 1
						)
					)
				)
			)
	
		)

	),
	
	fn joinVerts obj vertsArr =
	(
		if vertsArr.count >1 then
		(
			local wdpt = 0
			
			for i=1 to vertsArr.count do
				wdpt += polyop.getvert obj i
				
			wdpt = wdpt/vertsArr.count
				
		)
	),
	
	fn explodeFaces obj =
	(
		local faces=polyop.getfaceselection obj

		for i in faces do
		(
			facet=#(i)
			polyOp.detachFaces obj facet
		)
	),

	fn separateFaces obj =
	(
		local faces=polyop.getfaceselection obj
		polyOp.detachFaces obj faces
	)
)