macroScript EPOs_blendEdges
category:"Polymagus Action Items"
buttonText:"Blend Edges"
toolTip:"Blend Edges"--"Blend Selected Edges"
(
	on IsEnabled return (filters.Is_EditPoly() and (subobjectlevel == 2))
	on IsVisible return (filters.Is_EditPoly() and (subobjectlevel == 2))

	on Execute do
	(
		try
		(
			undo "Blend Edges" on
			(
				local edgelist=eposlibs.bitarrayToArray(polyOp.getEdgeSelection $.baseobject)
				
				if edgelist.count == 2 then
				(
					if (eposlibs.isedgeneighbor $.baseobject edgelist[1] edgelist[2]) == false then
						epos.blend2Edges $.baseobject edgelist[1] edgelist[2]
					else
						epos.blendNeighEdges $.baseobject edgelist[1] edgelist[2]
				)
				else
					epos.blendEdges $.baseobject edgelist
			)
			redrawviews()
		)
		catch
		(
			enableSceneRedraw()
			enableSceneRedraw()
			redrawViews()
		)
	)

)

macroScript EPOs_separatePolygon
category:"Polymagus Action Items"
buttonText:"Separate Poly"
toolTip:"Separate Poly"--"Separate Selected Polygons"
(
	on IsEnabled return (filters.Is_EditPoly() and (subobjectlevel == 4))
	on IsVisible return (filters.Is_EditPoly() and (subobjectlevel == 4))

	on Execute do
	(
		undo "separatePolygon" on
		(
			epos.separateFaces $.baseobject
		)
	)
)

macroScript EPOs_explodePolygon
category:"Polymagus Action Items"
buttonText:"Explode Poly"
toolTip:"Explode Poly"--"Explode Selected Polygons"
(
	on IsEnabled return (filters.Is_EditPoly() and (subobjectlevel == 4))
	on IsVisible return (filters.Is_EditPoly() and (subobjectlevel == 4))

	on Execute do
	(
		undo "explodePoly" on
		(
			epos.explodeFaces $.baseobject
		)
	)
)

macroScript EPOs_drawEdgesOnGrid
category:"Polymagus Action Items"
buttonText:"DrawPoly"	
toolTip:"DrawPoly on Grid"--"Draw Polygon on Active Grid (poly)"
(
	on isVisible return (if (selection.count == 1 and filters.Is_EditPoly()) then return true else if selection.count == 0 then return true)
	on isEnabled return (if (selection.count == 1 and filters.Is_EditPoly()) then return true else if selection.count == 0 then return true)
	on Execute do 
	(
		if selection.count == 0 then
		(
			with redraw off
			(
				setCommandpaneltaskmode mode:#modify
				local newPolyObj = convertTo (Editable_Mesh()) Editable_Poly
				newPolyObj.name=uniqueName "DrawPolyObject"
				select newPolyObj
			)
			
			global drawPolyHasVertCreated = false

			epos.drawPoly newPolyObj false
			
			newPolyObj.pivot=newPolyObj.center
			if drawPolyHasVertCreated == false then 
			with redraw off 
			(
					subobjectlevel = 0
					delete newPolyObj
			)
				
			drawPolyHasVertCreated = false
		)
		else
			epos.drawPoly $.baseobject false
	)
)

macroScript EPOs_vertAvg
category:"Polymagus Action Items"
buttonText:"Average Vertices"	
toolTip:"Averages Selected Vertices"
(
	on isVisible return filters.Is_EditPoly() and selection.count == 1 and subobjectlevel == 1
	on isEnabled return filters.Is_EditPoly() and selection.count == 1 and subobjectlevel == 1
	on Execute do 
	(
		epos.averageVertices $.baseobject (polyOp.getVertSelection $.baseobject)
	)
)

macroScript EPOs_edgeJoin
category:"Polymagus Action Items"
buttonText:"Join Edges"	
toolTip:"Join Selected Edges"
(
	on isVisible return filters.Is_EditPoly() and selection.count == 1 and subobjectlevel == 2
	on isEnabled return filters.Is_EditPoly() and selection.count == 1 and subobjectlevel == 2
	on Execute do 
	(
		local edgeArr = (eposlibs.bitArrayToArray(polyop.getEdgeSelection $.baseobject))		

		disableSceneRedraw()
		if edgeArr.count == 2 then
			(epos.join2edges $.baseobject edgeArr[1] edgeArr[2])

		enableSceneRedraw()
		redrawViews()	
	)
)

macroScript EPOs_paintSelect
category:"Polymagus Action Items"
buttonText:"Paint Selection"	
toolTip:"Paint Selection"
(

	fn startVertPaint = 
	(
	thePainterInterface.undoStart()
	)
	
	fn strokeVertPaint = 
	(
		local paintVerts = thePainterInterface.getPointGatherHits $
		local selverts = polyop.getVertSelection $
		
		if keyboard.controlpressed == true then
		(
			polyop.setVertSelection $ (join selverts paintverts)
		)
		else 
		(
			if keyboard.altPressed == true then
				polyop.setVertSelection $ (selverts - paintverts)
			else
				$.selectedverts = paintVerts
		)
		
	)
	
	fn endVertPaint = 
	(
		local paintVerts = thePainterInterface.getPointGatherHits $
		local selverts = polyop.getVertSelection $
		
		if keyboard.controlpressed == true then
		(
			polyop.setVertSelection $ (join selverts paintverts)
		)
		else 
		(
			if keyboard.altPressed == true then
				polyop.setVertSelection $ (selverts - paintverts)
			else
				$.selectedverts = paintVerts
		)
		
		thePainterInterface.undoAccept()
	)
	
	
	fn cancelVertPaint = 
	(
		thePainterInterface.undoCancel()
	)
	
	fn systemEndVertPaint = 
	(
		thePainterInterface.undoCancel()
	)
	
	fn strokeFacePaint = 
	(
		local paintVerts = eposlibs.bitarrayToArray(thePainterInterface.getPointGatherHits $)
		local paintFaces = #()
		local selFaces = polyop.getFaceSelection $
		
		paintFaces = (polyOp.getFacesUsingVert $ paintVerts) as bitArray
		
		if keyboard.controlpressed == true then
		(
			polyop.setFaceSelection $ (eposlibs.bitArrayToArray(join selFaces paintFaces))
		)
		else 
		(
			if keyboard.altPressed == true then
				polyop.setFaceSelection $ (eposlibs.bitArrayToArray(selFaces - paintFaces))
			else
				polyOp.setFaceSelection $ paintFaces
		)
		
	)
	
	fn strokeEdgePaint = 
	(
		local paintVerts = eposlibs.bitarrayToArray(thePainterInterface.getPointGatherHits $)
		local paintEdges = #()
		local selEdge = polyop.getEdgeSelection $
		
		paintEdges = (polyOp.getEdgeUsingVert $ paintVerts) as bitArray
		
		if keyboard.controlpressed == true then
		(
			polyop.setEdgeSelection $ (eposlibs.bitArrayToArray(join selEdge paintEdges))
		)
		else 
		(
			if keyboard.altPressed == true then
				polyop.setEdgeSelection $ (eposlibs.bitArrayToArray(selEdge - paintEdges))
			else
				polyOp.setEdgeSelection $ paintEdges
		)
		
	)
	fn endFacePaint =
	(
		thePainterInterface.undoAccept()
	)
	
	on isVisible return filters.Is_EditPoly() and selection.count == 1 and (((subobjectlevel == 1) or (subobjectlevel == 2)) or subobjectlevel == 4)
	on isEnabled return filters.Is_EditPoly() and selection.count == 1 and (((subobjectlevel == 1) or (subobjectlevel == 2)) or subobjectlevel == 4)
	on isChecked return thepainterinterface.inPaintMode()
	on Execute do 
	(
		if showEndResult == true then
			displayTempPrompt "Show End Result is on. Turn it off before painting selection" 7000
		else
		(
			if (thepainterinterface.inPaintMode() != true) then
			(
				if keyboard.AltPressed == true then thePainterInterface.paintOptions()
				
				nodeList = $
				thePainterInterface.pointGatherEnable = TRUE
				thePainterInterface.initializeNodes 0 nodeList 	
				thePainterInterface.offMeshHitType = 2
				
				if subobjectlevel == 1 then
					thePainterInterface.scriptfunctions startVertPaint strokeVertPaint endVertPaint cancelVertPaint systemEndVertPaint
				else if subobjectlevel == 2 then
					thePainterInterface.scriptfunctions startVertPaint strokeEdgePaint endFacePaint cancelVertPaint systemEndVertPaint
					else
					thePainterInterface.scriptfunctions startVertPaint strokeFacePaint endFacePaint cancelVertPaint systemEndVertPaint
					
				thePainterInterface.startPaintSession()
			)
			else
				thePainterInterface.endPaintSession()
		)			
	)
	
	
	on altExecute type do
	(
		thePainterInterface.paintOptions()
	)

)
